from MenuMaker import indent, writeFullMenu, Entry as _Entry




menuFile = "~/GNUstep/Defaults/WMRootMenu"




class App(object) :
	def emit(self, level) :
		return ['%s("%s", EXEC, "%s")' % (indent(level), self.app.name, self.app.execmd)]




def _split(x) :
	return (x[:len(x) - 1], x[len(x) - 1])




class Menu(object) :
	def emit(self, level) :
		if self.empty :
			return []
		i = 0
		max = len(self) - 1
		result = ['%s("%s",' % (indent(level), self.name)]
		for x in self :
			if isinstance(x, Menu) :
				result += x.emit(level + 1)
				continue
			try :
				(es, le) = _split(x.emit(level + 1))
			except IndexError :
				continue
			result += es
			if i < max :
				result.append(le + ",")
			else :
				result.append(le)
			i += 1
		result.append('%s)' % indent(level))
		return result




class Root(Menu) :
	def __init__(self, *args) :
		super(Root, self).__init__(*args)
	def emit(self, level) :
		if writeFullMenu :
			return super(Root, self).emit(level)
		else :
			result = []
			for x in self :
				result += x.emit(level)
			return result




class Cmd(_Entry) :
	def __init__(self, command, title) :
		self.command = command
		self.title = title
	def emit(self, level) :
		return ["%s[%s] (%s)" % (indent(level), self.command, self.title)]
